#!BPY

""" Registration info for Blender menus: <- these words are ignored
Name: 'ColorDialog'
Blender: 243
Group: 'Materials'
Tip: 'ColorDialog'
"""

__author__ = "Keines"
__version__ = "ver 2007.09.16(Sun) 00:30"

__bpydoc__ = """\
Note:
 Blender 2.43 + Python 2.4
 Blender 2.44 + Python 2.5

 It should run on any Python and Tkinter supported platform.
"""

import Blender
from Blender import Window,Draw,BGL,Scene,Object,Material

from Tkinter import *
import tkColorChooser

# + User  Config
BaseMaterial='Material'

# + Title
Title		= 'ColorDialog'
by              = ' by '
VerWidth	= Draw.GetStringWidth(__version__)

# + BaseValue
SpcWidth	= 20
BtnHeight	= 20
BtnWidth	= 20

Label	= ['Col','Spe','Mir','@','Exit']
Label_Cal	= 0
Label_Spe	= 1
Label_Mir	= 2
Label_Clip	= 3
Label_Exit	= 4

# Col=0,Spe=1,Mir=2
ColMode=0
BtnList=[Draw.Create(0),Draw.Create(0),Draw.Create(0)]

StringBtn=Draw.Create('')
StringBtn.val=BaseMaterial

StringHtmlBtn=Draw.Create('')

BtnWidthString=180
BtnWidthCol=Draw.GetStringWidth(Label[Label_Cal])+SpcWidth
BtnWidthExit=Draw.GetStringWidth(Label[Label_Exit])+SpcWidth
ExitPos=BtnWidthString-BtnWidthExit+BtnWidth+4

Event_None	= 0
Event_Col	= 1
Event_Spe	= 2
Event_Mir	= 3
Event_Clip	= 4
Event_Exit	= 5

class ColorDialog(Frame):

  def __init__(self, master=None):
    #global StringHtmlBtn
    Frame.__init__(self, master)
    self.master.geometry('0x0+%d+%d' % ( self.winfo_screenwidth()  / 4,
                                         self.winfo_screenheight() / 4))
    self.master.withdraw()
    try:
      self.mat=Material.Get(StringBtn.val)
    except:
      self.mat=Material.New(StringBtn.val)
    if   ColMode==0:c=(self.mat.R*255,self.mat.G*255,self.mat.B*255)
    elif ColMode==1:c=(self.mat.specR*255,self.mat.specG*255,self.mat.specB*255)
    elif ColMode==2:c=(self.mat.mirR*255,self.mat.mirG*255,self.mat.mirB*255)
    colorTuple = tkColorChooser.askcolor(initialcolor=c)
    if colorTuple[0]:
      StringHtmlBtn.val='%02X%02X%02X' % colorTuple[0]
      c=[k/255.0 for k in colorTuple[0]]
      if   ColMode==0: self.mat.rgbCol = c
      elif ColMode==1: self.mat.specCol= c
      elif ColMode==2: self.mat.mirCol = c
      Window.Redraw(Window.Types['VIEW3D'])
      Window.Redraw(Window.Types['BUTS'])
    self.master.destroy()

def DrawGui():
    global StringBtn,StringHtmlBtn,BtnList
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size=[int(i) for i in size.list]  # FLOAT -> INT
    # Base Position
    x=20
    y=size[3]-BtnHeight
    # + Title
    z=y-5
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title+by+__author__)
    # + Button
    y-=BtnHeight+10
    #   - ColorDialog
    StringBtn=Draw.String('Mat:',Event_None,x,y,BtnWidthString+2,BtnHeight,StringBtn.val,255)
    Draw.Button (Label[Label_Clip],Event_Clip,x+BtnWidthString+4,y,SpcWidth,BtnHeight,"")
    k=x
    for i in range (3):
      BtnList[i] = Draw.Toggle(Label[Label_Cal+i]  ,Event_Col+i,k,y-BtnHeight-2 ,BtnWidthCol-2,BtnHeight,BtnList[i].val)
      k+=BtnWidthCol
    StringHtmlBtn=Draw.String('Hex:',Event_None,k+2,y-BtnHeight-2,BtnWidthString-k+BtnWidthCol+2,BtnHeight,StringHtmlBtn.val,255)
    
    # + Version
    y-=BtnHeight+26
    BGL.glRasterPos2f(x+2, y)
    Draw.Text(__version__)
    #   - Exit
    Draw.Button (Label[Label_Exit],Event_Exit,x+ExitPos,y,BtnWidthExit,BtnHeight,"")

def MatClip():
    global StringBtn
    ob=Blender.Scene.GetCurrent().objects.active
    if ob!=None:
      try:
        me=ob.getData()
        if me!=None:
          mats=me.materials[:]
          if (mats):
            mats=[m.name for m in mats]
            work=''
            for i,s in enumerate(mats):
	      work+='| %s %%x%d'%(s,i)
            i=Draw.PupMenu(work)
            if i!=-1:
              StringBtn.val = mats[i]
            Draw.Register(DrawGui, KeyEvent, ButtonEvent)
      except:
        None

def ButtonEvent(evt):
    global ColMode,BtnList
    if evt in [Event_Col,Event_Spe,Event_Mir]	:
      ColMode=evt-Event_Col
      BtnList[ColMode].val=0
      ColorDialog()
      Draw.Register(DrawGui, KeyEvent, ButtonEvent)
    elif (evt==Event_Clip)			: MatClip()
    elif (evt==Event_Exit)			: Draw.Exit()

def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) : return
    elif evt in [Draw.ESCKEY, Draw.QKEY]:
        Draw.Exit()

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
